package fr.doap.jdb;

import java.lang.ref.*;
import java.util.*;

public class WeakObjectCache {

	public Object getObject(int aID) {
		WeakReference<Object> lWR = mObjectCache.get(aID);
		if (lWR != null) return lWR.get();
		return null;
	}
	
	public int getId(Object aObject) {
		Integer lID = mIDs.get(aObject);
		if (lID != null) return lID;
		else return -1;
	}
	
	public Object put(int aID, Object aObject) {
		Object lOld = getObject(aID);
		mIDs.put(aObject, aID);
		mObjectCache.put(aID,new WeakReference<>(aObject));
		return lOld;
	}
	
	public void clear() {
		mIDs.clear();
		mObjectCache.clear();
	}
	
	Map<Object, Integer>				mIDs = new WeakHashMap<>();
	Map<Integer, WeakReference<Object>>	mObjectCache = new TreeMap<>();
}