package fr.doap.jdb.impl;

import fr.doap.slog.*;

import java.util.*;

public class ClassInfos {

	static public Map<String, Object> getProps(Object aObject) {
		Map<String, Object> lMap = new HashMap<>();
		ClassInfos lCI = get(aObject.getClass());
		if (lCI != null) {
			lCI.mPropsGetterSetter.forEach((aKey, aGS) -> {
				lMap.put(aKey, aGS.get(aObject))
			});
		}
		return lMap;
	}
	
	static public ClassInfos get(Class<?> aClass) {
		if ((aClass != null)&&(aClass != Object.class)) {
			ClassInfos lCI = sInfosMap.get(aClass);
			if (lCI == null) {
				lCI = new ClassInfos(aClass);
				sInfosMap.put(aClass, lCI);
			}
			return lCI;
		}
		return null;
	}
	
	ClassInfos(Class<?> aClass) {
		try {
			sInfosMap.put(aClass, this);
			Class<?> lSuper = aClass.getSuperclass();
			if (lSuper != Object.class) {
				ClassInfos lCI = get(lSuper);
				mPropsGetterSetter.putAll(lCI.mPropsGetterSetter);
			}
			for (ClassAnalyzer iCA: sClassAnalyzers) {
				if (iCA.isApplicable(aClass)) {
					mPropsGetterSetter.putAll(iCA.analyze(aClass));
					break;
				}
			}
		} catch (Exception aE) { L.t(aE); }
	}

	
	
	private Map<String, PropGetterSetter> mPropsGetterSetter = new HashMap<>();
	
	static Map<Class<?>, ClassInfos>	sInfosMap = new HashMap<>();
	static List<ClassAnalyzer>			sClassAnalyzers = new ArrayList<>(List.of(new ClassAnalyzer.Collection(), new ClassAnalyzer.Field()));
}
